Player = {}
require "bag"

function Player:new(posx,posy)
	local object=
	{
		speed=15,
		actualXSpeed=0,
		actualYSpeed=0,
		topSpeed=250,
		friction=5,
		moral=100,
		fear=math.random(25,75),
		posX=posx,
		posY=posy,
		height=32,
		width=16,
		nobleness=math.random(100),
		gold=25,
		favors=0,
		inventory=Bag:new(0),
		thugs={}
	}
	setmetatable(object,{__index=Player})
	return object
end

function Player:update(dt,mov,limits)
	retorno=false
	
	--Desaceleración por fricción
	if self.actualYSpeed~=0 then
		if self.actualYSpeed<0 then 
			self.actualYSpeed=self.actualYSpeed+self.friction
			if self.actualYSpeed>0 then self.actualYSpeed=0 end
		end
		if self.actualYSpeed>0 then 
			self.actualYSpeed=self.actualYSpeed-self.friction
			if self.actualYSpeed<0 then self.actualYSpeed=0 end
		end
	end
	if self.actualXSpeed~=0 then
		if self.actualXSpeed<0 then 
			self.actualXSpeed=self.actualXSpeed+self.friction
			if self.actualXSpeed>0 then self.actualXSpeed=0 end
		end
		if self.actualXSpeed>0 then 
			self.actualXSpeed=self.actualXSpeed-self.friction
			if self.actualXSpeed<0 then self.actualXSpeed=0 end
		end
	end
	
	--Aceleración
	if mov~=5 then
		if self.actualYSpeed~=self.topSpeed and self.actualYSpeed~=self.topSpeed*-1 then
			if mov>6 then 
				self.actualYSpeed=self.actualYSpeed-self.speed
				if self.actualYSpeed<self.topSpeed*-1 then self.actualYSpeed=self.topSpeed*-1 end
			elseif mov<4 then
				self.actualYSpeed=self.actualYSpeed+self.speed
				if self.actualYSpeed>self.topSpeed then self.actualYSpeed=self.topSpeed end
			end
		end
		if self.actualXSpeed~=self.topSpeed and self.actualXSpeed~=self.topSpeed*-1 then
			if mov==1 or mov==4 or mov==7 then 
				self.actualXSpeed=self.actualXSpeed-self.speed
				if self.actualXSpeed<self.topSpeed*-1 then self.actualXSpeed=self.topSpeed*-1 end
			elseif mov==3 or mov==6 or mov==9 then
				self.actualXSpeed=self.actualXSpeed+self.speed
				if self.actualXSpeed>self.topSpeed then self.actualXSpeed=self.topSpeed end
			end
		end
		retorno=true
	end
	
	self.posY=self.posY+self.actualYSpeed*dt
	self.posX=self.posX+self.actualXSpeed*dt
	
	return retorno
end